-- Visualization of Lazy Evaluation and Sharing
-- Chapter 4: Evaluation
-- Section 4.2: Visualizations
-- Subsection 4.2.10: Negative Effects of Lazy Evaluation and Sharing

import Prelude hiding (sum)

sum   :: (Num a) => [a] -> a
sum l = sum' l 0
  where
    sum' []     a = a
    sum' (x:xs) a = sum' xs (a + x)

sum2   :: (Num a) => [a] -> a
sum2 l = sum' l 0
  where
    sum' []     a = a
    sum' (x:xs) a = sum' xs $! (a + x)
