-- Visualization of Lazy Evaluation and Sharing
-- Chapter 4: Evaluation
-- Section 4.2: Visualizations
-- Subsection 4.2.2: Sharing

complexOperation :: Double -> Double
--complexOperation x = x + 1
complexOperation x = x ** 9 - sqrt (x ** 5) + sqrt (sqrt (x ** 3))

f      :: Double -> Int -> [Double]
f x 0  = []
f x y  = complexOperation x : f x (y - 1)

g      :: Int -> [Double]
g y    = f 235 y

f'     :: Double -> Int -> [Double]
f' x 0 = []
f' x y = go (complexOperation x) y
  where go x' 0 = []
        go x' y = x' : go x' (y - 1)

g'     :: Int -> [Double]
g' y   = f' 235 y
