-- Visualization of Lazy Evaluation and Sharing
-- Chapter 4: Evaluation
-- Section 4.2: Visualizations
-- Subsection 4.2.6: Double Linked List

-- This code is from http://www.haskell.org/haskellwiki/Tying_the_Knot

data DList a = DLNode (DList a) a (DList a)

mkDList    :: [a] -> DList a
mkDList [] = error "must have at least one element"
mkDList xs = let (first,last) = go last xs first
             in  first

  where go :: DList a -> [a] -> DList a -> (DList a, DList a)
        go prev []     next = (next,prev)
        go prev (x:xs) next = let this        = DLNode prev x rest
                                  (rest,last) = go this xs next
                              in  (this,last)
